#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Avalon Bookmark importer
# Licensed under GPL

import os
import sys

class import_bookmarks():
	#TODO: Make separate functions for each file type
	def __init__(self, bookfile):
		"""Load bookmark file into memory"""
			
		self.bookfile = bookfile
		
		try:
			f = open(self.bookfile, 'r')
			self.data = f.read()
			f.close()
		
			ft = os.popen('file -bi ' + self.bookfile, 'r')
			self.mime = ft.read()
			ft.close()			
		except:
			print 'Could not import bookmarks from: ' + self.bookfile
			sys.exit(1)
		
			
	def make_list(self):
		"""Returns a list with link, feedname and visible separated by ,"""
		feedlist = []
		
		if self.mime.startswith('text/html'):
			lines = self.data.split('\n')
			
			for line in lines:
				if line.find('FEEDURL=') > -1:
					name = line[:-4].split('">')[1]
					line = line.split()
					
					for part in line:
						if part.startswith('FEEDURL='):
							feedlist.append(part[9:-1] + ',' + name + ',0')
											
		elif self.mime.startswith('application/xml'):
			lines = self.data.split('\n')
			
			for line in lines:
				snum = line.strip().find('title=')
				
				if snum > -1:
					name = line.strip()[snum + 7:].split('"')[0]
					rawurl = lines[lines.index(line) + 1].strip()
					feedlist.append(rawurl[8:].split('"')[0] + ',' + name + ',0')
					
		elif self.mime.startswith('text/plain'):
			lines = self.data.split('title')
			
			for line in lines:	
				if line.find('livemark/feedURI') > -1:
					feedlist.append(line[line.find('http'):].split('"')[0] + ',' + line[3:].split('"')[0] + ',0')
				
		return feedlist
