#!/usr/bin/python
# -*- coding: utf-8 -*-

# Avalon settingsparser 1.0
# Licensed under GPL


#TODO: Change name, AMCM (All-mighty config module) ?

import sys
import webbrowser



class Config:
	
	def load(self):
		"""Returns the config file as list"""
		
		try:
			f = file(sys.path[0] + '/data/config', 'r')	
		except:
			print 'Could not open config file'
			sys.exit(0)
			
		data = f.read().splitlines()
		f.close()
		return data


	def feeds(self):
		"""Returns all feeds as list"""
		
		feedlist = []
		rawdata = self.load()[0].split('==')[1]
		
		rawdata = rawdata.split(',')
		
		for m in rawdata:
			feed = m.split('[')[0] + ',' + m.split('[')[1][:-2] + ',' + m.split('[')[1][-1:]
			feedlist.append(feed)
			
		return feedlist
			

	def notify(self):
		"""Returns True or False"""

		rawdata = self.load()[1].split('==')[1]
		
		if rawdata == 'True':
			return True
		else:
			return False
			
			
	def updateinterval(self):
		"""Returns the update time as integer in seconds"""
		
		rawdata = self.load()[2].split('==')[1]
		return int(rawdata) * 60
		
		
	def browser(self):
		"""Returns a list with browser name as string at index 0 
		and browser object at index 1"""
		
		browser = []
		browser.append(self.load()[3].split('==')[1])
		
		try:
			browser.append(webbrowser.get(self.load()[3].split('==')[1]))
			return browser
		except:
			print 'Browser not found'
			sys.exit(0)
			
			
	def maxfeeds(self):
		"""Returns max shown feeds as integer"""
		
		rawdata = self.load()[4].split('==')[1]
		return int(rawdata)
		
		
	def Write(self, id, value):
		"""Writes selected value to config
		   updateinterval and browser value should be integer
		   feeds value should be a list"""
		
		#TODO: Make this function prettier, must be a better way to solve this,[Fixed to next version]
		
		temp = ''
		for fe in self.feeds():
			temp = temp + fe.split(',')[0] + '[' + fe.split(',')[1] + ']' + fe.split(',')[2] + ','
		

		if self.notify():	
			notify = 'True'
		else:
			notify = 'False'	
		
		cf = {'feeds': temp[:-1] + '\n',
			 'notify': notify + '\n',
			 'updateinterval': str(self.updateinterval() / 60) + '\n',
			 'browser': self.browser()[0] + '\n',
			 'maxfeeds': str(self.maxfeeds()) + '\n'}

		if id == 'feeds':
			
			temp = ''
			for fe in value:
				temp = temp + fe.split(',')[0] + '[' + fe.split(',')[1] + ']' + fe.split(',')[2] + ','
			cf['feeds'] = temp[:-1] + '\n'	
		else:
			cf[id] = str(value) + '\n'
		
		
		try:
			f = file(sys.path[0] + '/data/config', 'w')	
					
			f.write('feeds==' + cf['feeds'] + 'notify==' + cf['notify'] + 
			'updateinterval==' + cf['updateinterval'] + 'browser==' + cf['browser'] + 	
			'maxfeeds==' + cf['maxfeeds'])
		
		
		except:
			print 'Could not write to config'
			sys.exit(0)
		
		f.close()
